﻿using System.Configuration;
using System.Data.SqlClient;
using NIntegrateQueryPerformanceComparison.LinqToSql;

namespace NIntegrateQueryPerformanceComparison.AdoNet
{
    class AdoNetTest : ITest
    {
        private static readonly string _connString = ConfigurationManager.ConnectionStrings[Constants.ConnectingStringName].ConnectionString;

        private void DoExecute(int repeatTime)
        {
            for (var i = 1; i <= repeatTime; ++i)
            {
                using (var conn = new SqlConnection(_connString))
                {
                    if (conn.State != System.Data.ConnectionState.Open)
                        conn.Open();
                    var cmd = new SqlCommand(
                        "SELECT TOP 1 ProductID,Name FROM SalesLT.Product WHERE ProductID = @ProductID", conn)
                                  {CommandType = System.Data.CommandType.Text};
                    cmd.Parameters.Add(new SqlParameter("@ProductID", i));
                    using (var reader = cmd.ExecuteReader())
                    {
                        if (reader.Read())
                        {
                            var product = new Product
                                              {
                                                  ProductID = ((int) reader["ProductID"]),
                                                  Name = ((string) reader["Name"])
                                              };
                        }
                    }
                }
            }
        }

        #region ITest Members

        public void Prepare()
        {
            DoExecute(1);
        }

        public void Execute()
        {
            DoExecute(Constants.RepeatTime);
        }

        #endregion
    }
}
