﻿using System.Configuration;
using System.Data.SqlClient;
using System.Linq;

namespace NIntegrateQueryPerformanceComparison.LinqToSql
{
    class LinqToSqlTest : ITest
    {
        private static readonly string _connString = ConfigurationManager.ConnectionStrings[Constants.ConnectingStringName].ConnectionString;

        private void DoExecute(int repeatTime)
        {
            for (var i = 1; i <= repeatTime; ++i)
            {
                using (var conn = new SqlConnection(_connString))
                {
                    if (conn.State != System.Data.ConnectionState.Open)
                        conn.Open();

                    var ctx = new AdventureWorksDataContext(conn);
                    var product = ctx.Products.SingleOrDefault(p => p.ProductID == i);
                }
            }
        }

        #region ITest Members

        public void Prepare()
        {
            DoExecute(1);
        }

        public void Execute()
        {
            DoExecute(Constants.RepeatTime);
        }

        #endregion
    }
}
