﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using NIntegrate.Query.Command;
using NIntegrateQueryPerformanceComparison.LinqToSql;

namespace NIntegrateQueryPerformanceComparison.NIntegrateQuery
{
    class NIntegrateQueryTest : ITest
    {
        private static readonly string _connString = ConfigurationManager.ConnectionStrings[Constants.ConnectingStringName].ConnectionString;

        private void DoExecute(int repeatTime)
        {
            for (var i = 1; i <= repeatTime; ++i)
            {
                var criteria = new ProductCriteria();
                var cmd = new QueryCommandFactory(criteria.And(criteria.ProductID == i))
                    .GetQueryCommand();
                cmd.Parameters.Add(new SqlParameter("@ProductID", i));
                cmd.Connection.Open();
                using (var reader = cmd.ExecuteReader())
                {
                    if (reader.Read())
                    {
                        var product = new Product
                                          {
                                              ProductID = ((int) reader["ProductID"]),
                                              Name = ((string) reader["Name"])
                                          };
                    }
                    cmd.Connection.Close();
                }
            }
        }

        #region ITest Members

        public void Prepare()
        {
            DoExecute(1);
        }

        public void Execute()
        {
            DoExecute(Constants.RepeatTime);
        }

        #endregion
    }
}
