﻿using System;
using System.Diagnostics;

namespace NIntegrateQueryPerformanceComparison
{
    class Program
    {
        static void Main(string[] args)
        {
            var tests = new ITest[]
                            {
                                new AdoNet.AdoNetTest(),
                                new AdoNet.AdoNetCachedCommandTest(),
                                new LinqToSql.LinqToSqlTest(),
                                new LinqToSql.LinqToSqlCompiledQueryTest(),
                                new NIntegrateQuery.NIntegrateQueryTest()
                            };

            foreach (var test in tests)
            {
                var stopWatch = new Stopwatch();
                stopWatch.Start();
                test.Prepare();
                test.Execute();
                stopWatch.Stop();

                Console.WriteLine(string.Format("{0}: {1}ms", test.GetType().Name, stopWatch.ElapsedMilliseconds));
            }

            Console.ReadLine();
        }
    }
}
